package KorAP::VirtualCorpus::GroupRef;
use strict;
use warnings;
use base 'KorAP::VirtualCorpus';

# TODO:
# Maybe replaceble with DocVec

# Constructor
sub new {
  my $class = shift;
  bless {
    reference => shift,
    match => 'eq',
  }, $class;
};


# Clone document VC
sub clone {
  my $self = shift;
  bless {
    reference =>   $self->{reference},
    match => $self->{match},
  }, __PACKAGE__;
};


# Return object type
sub koral_type {
  return 'DocGroupRef';
};


# Get or set match
sub match {
  my $self = shift;
  if (@_) {
    $self->{match} = shift;
    return $self;
  };
  return $self->{match};
};


# Get or set reference
sub reference {
  my $self = shift;
  if (@_) {
    $self->{reference} = shift;
    return $self;
  };
  return $self->{reference};
};


# Stringify fragment
sub _to_fragment {
  my $self = shift;
  my $json = '{';
  $json .= '"@type":"koral:docGroupRef",';
  $json .= '"ref":"' . $self->reference . '"';
  $json .= ',"match":"match:' . $self->match . '"' if $self->match ne 'eq';

  # Set at the end, when all comments are done
  $json .= $self->_commentparam_to_string;
  return $json . '}';
};


1;
